package com.madeu.controller.web.websms;

import com.madeu.constants.Constants;
import com.madeu.service.web.websms.WebSmsService;
import com.madeu.common.service.LogHistoryService;
import com.madeu.util.HttpUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;


@Slf4j
@Controller
public class WebSmsController{

	@Autowired
	private WebSmsService webSmsService;
	
	@Autowired
	private LogHistoryService logHistoryService;

	/**
	 * 문자 정보 리스트 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/websms/selectListSms.do")
	public ModelAndView selectListSms(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebSmsController selectListSms START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
			map = webSmsService.selectListSms(paramMap);
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebSmsController selectListSms END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 문자 정보 상세 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/websms/selectSms.do")
	public ModelAndView selectSms(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebSmsController selectSms START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
			map = webSmsService.selectSms(paramMap);
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebSmsController selectListSms END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**	
	 * 문자 정보 등록
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/websms/insertSms.do")
	public ModelAndView insertSms(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
		log.debug("WebSmsController insertSms START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();

		try{
			paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
			paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
			paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
			map = webSmsService.insertSms(paramMap);
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

						logHistoryService.save("문자 등록", "문자", paramMap, map, String.valueOf(errorMsg));
		}
		log.debug("WebSmsController insertSms END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 문자 정보 등록 - 홈
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/websms/insertSmsHome.do")
	public ModelAndView insertSmsHome(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
		log.debug("WebSmsController insertSmsHome START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();

		try{
			paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
			paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
			paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
			map = webSmsService.insertSmsHome(paramMap);
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

						logHistoryService.save("문자 등록 - 홈", "문자", paramMap, map, String.valueOf(errorMsg));
		}
		log.debug("WebSmsController insertSmsHome END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 문자 정보 등록 - 상담 차트
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/websms/insertSmsConsultingChart.do")
	public ModelAndView insertSmsConsultingChart(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
		log.debug("WebSmsController insertSmsConsultingChart START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();

		try{
			paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
			paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
			paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
			map = webSmsService.insertSmsConsultingChart(paramMap);
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

						logHistoryService.save("문자 등록 - 상담 차트", "문자", paramMap, map, String.valueOf(errorMsg));
		}
		log.debug("WebSmsController insertSmsConsultingChart END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

}
